###########################################################
# setup 'stdrc_linux.sh' - Bash shell		              #
#                                                         #
# Created by Keith Thorne, 8 July 2010                    #
#                                                          #
# DO NOT EDIT THIS FILE!                                  #
# This file is part of a production system.               #
###########################################################
# Changes to it effect everyone.  Please play nice        #
# and contact the CDS sys admin if you feel this file     #
# needs to be changed.                                    #
#                                                         #
#  $Id: stdrc_linux.sh 983 2010-08-17 17:16:42Z keith.thorne@LIGO.ORG $
###########################################################

# set location of setup scripts
setupscriptdir=${cfgbase}/${site}/${ifo}

# Set some shell defaults
# - limit size of core dumps, use soft limit to allow overrides
ulimit -S -c 100000

# setup X-windows DISPLAY variable
if [ "$REMOTEHOST" ]; then
   if [ ! "$DISPLAY" ]; then
      export DISPLAY=$REMOTEHOST":0"
   fi
elif [ ! "$DISPLAY" ]; then
   export DISPLAY=unix:0
fi
# GLOBAL VARIABLES
export SVN_EDITOR=vim

# define useful functions for adding to paths
addpath()
{
#  addpath - add to PATH if not already there
    thispath=$1
    if [[ ":$PATH:" != *":$thispath:"* ]]; then 	
        export PATH=${PATH}:${thispath}
    fi
}
prepath()
{
#  prepath - add first to PATH if not already there
    thispath=$1
    if [[ ":$PATH:" != *":$thispath:"* ]]; then 	
        export PATH=${thispath}:${PATH}
    fi
}
addlib()
{
#  addlib - add to LD_LIBRARY_PATH if not already there
    thislib=$1
    if [ -z "$LD_LIBRARY_PATH" ] ; then
	    export LD_LIBRARY_PATH=${thislib}
    elif [[ ":$LD_LIBRARY_PATH:" != *":$thislib:"* ]]; then 	
        export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${thislib}
    fi
}
prelib()
{
#  prelib - add first to LD_LIBRARY_PATH if not already there
    thislib=$1
    if [ -z "$LD_LIBRARY_PATH" ] ; then
	    export LD_LIBRARY_PATH=${thislib}
    elif [[ ":$LD_LIBRARY_PATH:" != *":$thislib:"* ]]; then 	
        export LD_LIBRARY_PATH=${thislib}:${LD_LIBRARY_PATH}
    fi
}
addmatlab()
{
#  addmatlab - add first to MATLABPATH if not already there
    thismat=$1
    if [[ ":$MATLABPATH:" != *":$thismat:"* ]]; then 	
        export MATLABPATH=${thismat}:${MATLABPATH}
    fi
}
#  Define default Python version for older OS
DEFPY=2
# Get info on OS - define apps root
#  Check if gentoo
if [ -e /etc/gentoo-release ] ; then
#  If gentoo, determine kernel version
    distname="Gentoo"
    kernrel=`uname -r`
#   get first part
    kernmajor=${kernrel%%.*}
#   from the rest, get the next one 
    kernremain=${kernrel#*.}
    kernminor=${kernremain%%.*}
# the earliest gentoo systems just used /ligo/apps or /opt/rtapps
    if [[ "$kernmajor" == "2" ]]; then
	OS_ARCH=linux-x86_64
        APPSROOT=${APPSBASEDIR}
    else
	OS_ARCH=gentoo$kernmajor"-"$kernminor
        APPSROOT=${APPSBASEDIR}/$OS_ARCH
    fi
else
# If not gentoo, get the distribution and release from /etc/os-release
    distname=`/usr/bin/awk -F = '$1 == "ID" {gsub(/"/, "", $2); print $2}' <  "/etc/os-release"`
    distrel=`/usr/bin/awk -F = '$1 == "VERSION_ID" {gsub(/"/, "", $2); print $2}' <  "/etc/os-release"`
    distnum=${distrel%%.*}
# check if Ubuntu
    if [[ "$distname" == "ubuntu" ]]; then
        OS_ARCH=ubuntu$distnum
        if [ "$distnum" -gt "16" ]; then
            PYDEF=3
        fi  
# check if Scientific Linux
    elif [[ "$distname" == "scientific" ]]; then
        OS_ARCH=sl$distnum
        if [ "$distnum" -gt "7" ]; then
            PYDEF=3
        fi   
# check if Rocky
    elif [[ "$distname" == "rocky" ]]; then
        OS_ARCH=rocky$distnum
        if [ "$distnum" -gt "7" ]; then
            PYDEF=3
        fi   
# check if CentOS
    elif [[ "$distname" == "centos" ]]; then
        OS_ARCH=centos$distnum
        if [ "$distnum" -gt "7" ]; then
            PYDEF=3
        fi   
# check if Debian
    elif [[ "$distname" == "debian" ]]; then
        OS_ARCH=debian$distnum
        if [ "$distnum" -gt "9" ]; then
            PYDEF=3
        fi   
# otherwise, mark generic
    else
        OS_ARCH=linux-x86_64
    fi
    APPSROOT=${APPSBASEDIR}/$OS_ARCH
fi
#
export APPSROOT
export OS_ARCH

#
# ** Setup EPICS/MEDM **
if [ -e ${APPSROOT}/epics/etc/epics-user-env.sh ] ; then
    source ${APPSROOT}/epics/etc/epics-user-env.sh
else
    USING_SYSTEM_EPICS=1
    export USING_SYSTEM_EPICS
fi
# add Probe, MEDM Editor to MEDM exec list
if [ -z "${MEDM_EXEC_LIST}" ]; then
    export MEDM_EXEC_LIST="Probe;probe &P &:MEDM Editor;medm \`readlink -e &A\` &"
else
    if [[ "${MEDM_EXEC_LIST}" != *"MEDM"* ]]; then 	
        export MEDM_EXEC_LIST="MEDM Editor;medm \`readlink -e &A\` &:${MEDM_EXEC_LIST}"
    fi
    if [[ "${MEDM_EXEC_LIST}" != *"Probe"* ]]; then 	
        export MEDM_EXEC_LIST="Probe;probe &P &:${MEDM_EXEC_LIST}"
    fi
fi
export EPICS_DISPLAY_PATH=${CDSROOT}/medm
alias m0='pushd ${CDSROOT}/medm'
alias mr='pushd ${RTCDSROOT}/medm'
alias medm_a='medm -displayFont alias'
alias medm_f='medm -displayFont fixed'
# sitemap - spawns MEDM, opening sitemap
alias sitemap_a='medm -x -displayFont alias ${CDSROOT}/medm/sitemap.adl &'
alias sitemap_f='medm -x -displayFont fixed ${CDSROOT}/medm/sitemap.adl &'
alias sitemap='medm -x -displayFont alias ${CDSROOT}/medm/sitemap.adl &'
#
export CAQTDM_DISPLAY_PATH=${CDSROOT}/medm
alias qtmap='caQtDM -x ${CDSROOT}/qtdm/qtmap.ui &'
alias qtdm='designer-caqtdm &'
alias qtsite='caQtDM -x ${CDSROOT}/medm/sitemap.ui &'
#
# check for matlab version install before creating alias

if [ -f "${APPSROOT}/matlab_r2012b/bin/matlab" ] ; then
    alias matlab_r2012b='${APPSROOT}/matlab_r2012b/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2015b/bin/matlab" ] ; then
    alias matlab_r2015b='${APPSROOT}/matlab_r2015b/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2016a/bin/matlab" ] ; then
    alias matlab_r2016a='${APPSROOT}/matlab_r2016a/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2016b/bin/matlab" ] ; then
    alias matlab_r2016b='${APPSROOT}/matlab_r2016b/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2018a/bin/matlab" ] ; then
    alias matlab_r2018a='${APPSROOT}/matlab_r2018a/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2019a/bin/matlab" ] ; then
    alias matlab_r2019a='${APPSROOT}/matlab_r2019a/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2019b/bin/matlab" ] ; then
    alias matlab_r2019b='${APPSROOT}/matlab_r2019b/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2020a/bin/matlab" ] ; then
    alias matlab_r2020a='${APPSROOT}/matlab_r2020a/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2020b/bin/matlab" ] ; then
    alias matlab_r2020b='${APPSROOT}/matlab_r2020b/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2021a/bin/matlab" ] ; then
    alias matlab_r2020a='${APPSROOT}/matlab_r2021a/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2022a/bin/matlab" ] ; then
    alias matlab_r2020a='${APPSROOT}/matlab_r2022a/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2023a/bin/matlab" ] ; then
    alias matlab_r2020a='${APPSROOT}/matlab_r2023a/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2023b/bin/matlab" ] ; then
    alias matlab_r2020b='${APPSROOT}/matlab_r2023b/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2024a/bin/matlab" ] ; then
    alias matlab_r2020a='${APPSROOT}/matlab_r2024a/bin/matlab'
fi
if [ -f "${APPSROOT}/matlab_r2024a/bin/matlab" ] ; then
    alias matlab_r2020a='${APPSROOT}/matlab_r2024a/bin/matlab'
fi

if [ -d "${APPSROOT}/mathematica/bin" ]; then
    addpath ${APPSROOT}/mathematica/bin
fi

# ** setup DataViewer **
if [[ -d "${APPSROOT}/dv" ]]; then
    prepath ${APPSROOT}/dv
else
    USING_SYSTEM_DV=1
    export USING_SYSTEM_DV
fi
# ** setup grace if not local
if [[ ! -d "/usr/share/grace" ]]; then
    if [ -f "${APPSROOT}/grace/etc/grace-user-env.sh" ] ; then
	source ${APPSROOT}/grace/etc/grace-user-env.sh
    fi
else
    USING_SYSTEM_GRACE=1
    export USING_SYSTEM_GRACE
fi

# -- prep for GDS
# If ldas-tools present, use that
#    Otherwise use framecpp
if [[ -d "${APPSROOT}/ldas-tools/etc" ]]; then
    source ${APPSROOT}/ldas-tools/etc/ldas-tools-user-env.sh
elif [ -e ${APPSROOT}/framecpp/etc/framecpp-user-env.sh ]; then
    source ${APPSROOT}/framecpp/etc/framecpp-user-env.sh
else
    USING_SYSTEM_FRAMECPP=1
    export USING_SYSTEM_FRAMECPP
fi
# - fftw
if [ -e ${APPSROOT}/fftw/etc/fftw-user-env.sh ] ; then
    source ${APPSROOT}/fftw/etc/fftw-user-env.sh
else
    USING_SYSTEM_FFTW=1
    export USING_SYSTEM_FFTW
fi
# - libframe
if [ -e ${APPSROOT}/libframe/etc/libframe-user-env.sh ] ; then
    source ${APPSROOT}/libframe/etc/libframe-user-env.sh
else
    USING_SYSTEM_LIBFRAME=1
    export USING_SYSTEM_LIBFRAME
fi
# - metaio
if [ -e ${APPSROOT}/metaio/etc/metaio-user-env.sh ] ; then
    source ${APPSROOT}/metaio/etc/metaio-user-env.sh
else
    USING_SYSTEM_METAIO=1
    export USING_SYSTEM_METAIO
fi
#  set up ROOT
if [ -e ${APPSROOT}/root/etc/root-user-env.sh ] ; then
    source ${APPSROOT}/root/etc/root-user-env.sh
else
    USING_SYSTEM_ROOT=1
    export USING_SYSTEM_ROOT
    ROOTSYS="/usr"
    export ROOTSYS
fi

# - set up GDS
if [ -e ${APPSROOT}/gds/etc/gds-user-env.sh ] ; then
    source ${APPSROOT}/gds/etc/gds-user-env.sh
else
    USING_SYSTEM_GDS=1
    export USING_SYSTEM_GDS
fi
# - set up awgstream if separate
if [ -e ${APPSROOT}/awgstream/etc/awgstream-user-env.sh ] ; then
    source ${APPSROOT}/awgstream/etc/awgstream-user-env.sh
fi

# - set up python tools
if [ -e ${APPSROOT}/pytools/etc/pytools-user-env.sh ] ; then
    source ${APPSROOT}/pytools/etc/pytools-user-env.sh
fi
if [ -e ${APPSROOT}/gpstime/etc/gpstime-user-env.sh ] ; then
    source ${APPSROOT}/gpstime/etc/gpstime-user-env.sh
fi
if [ -e ${APPSROOT}/cdsutils/etc/cdsutils-user-env.sh ] ; then
    source ${APPSROOT}/cdsutils/etc/cdsutils-user-env.sh
fi

# alias tconvert
alias tconvert="gpstime -g UTC"

# Find Python rev for guardian
# If we are in conda shell
#   Use conda python to locate guardian package
# Otherwise
#  If Python 3 installed
#    Use that to locate it
#  Otherwise
#    check default python
#  If we have a python, try to locate guardian package
condaactive=0
if [[ -v CONDA_SHLVL ]] ; then
  if [ "$CONDA_SHLVL" -gt "0" ] ; then
    condaactive=1
    fullpyvers=$(${CONDA_PREFIX}/bin/python -c 'import platform; print(platform.python_version())')
    PYTHONREV=`echo ${fullpyvers} | sed -n -e 's/^\([0-9]*\.[0-9]*\).*/\1/p'`
    export PYTHONREV
    # find out where Guardian is - RHEL has site-packages, Debian has dist-packages
    if [ -e "${CONDA_PREFIX}/lib/python${PYTHONREV}/site-packages/guardian" ]; then
        GUARDIANPYTHON=${CONDA_PREFIX}/lib/python${PYTHONREV}/site-packages
    else
        if [ -e "${CONDA_PREFIX}/lib/python${PYTHONREV}/dist-packages/guardian" ]; then
            GUARDIANPYTHON=${CONDA_PREFIX}/lib/python${PYTHONREV}/dist-packages
        else
            GUARDIANPYTHON=${CONDA_PREFIX}/lib/python${PYTHONREV}
        fi
    fi
    export GUARDIANPYTHON
  fi
fi
if [ "${condaactive}" -eq "0" ] ; then
    if [ -e "/usr/bin/python3" ] ; then
        fullpyvers=$(/usr/bin/python3 -c 'import platform; print(platform.python_version())')
    else
        pyposs=python$PYDEF
        if [ -e "/usr/bin/${pyposs}" ] ; then
            fullpyvers=$(/usr/bin/${pyposs} -c 'import platform; print(platform.python_version())')
        else
			if [ -e /usr/bin/python ] ; then
                fullpyvers=$(/usr/bin/python -c 'import platform; print(platform.python_version())')
            else
                fullpyvers=0
            fi
        fi
    fi
    if [ $fullpyvers != "0" ] ; then
        # get Python version
        PYTHONREV=`echo ${fullpyvers} | sed -n -e 's/^\([0-9]*\.[0-9]*\).*/\1/p'`
        export PYTHONREV
        # basic system Python path
        PYTHONLIB=/usr/lib/python${PYTHONREV}
        # find out where Guardian is - RHEL has site-packages, Debian has dist-packages
        if [ -e "${PYTHONLIB}/site-packages/guardian" ] ; then
           GUARDIANPYTHON=${PYTHONLIB}/site-packages
        else
           if [ -e "${PYTHONLIB}/dist-packages/guardian" ] ; then
              GUARDIANPYTHON=${PYTHONLIB}/dist-packages
           else
              GUARDIANPYTHON=${PYTHONLIB} 
           fi
        fi
    fi
    export GUARDIANPYTHON
fi
# remember to add Guardian mini-screens to EPICS_DISPLAY_PATH
if [ -e "${GUARDIANPYTHON}/guardian/medm/screens" ] ; then
    GUARDIANSCREENS=${GUARDIANPYTHON}/guardian/medm/screens
    export GUARDIANSCREENS
    EPICS_DISPLAY_PATH=${GUARDIANSCREENS}:${EPICS_DISPLAY_PATH}
    export EPICS_DISPLAY_PATH
fi

# - if ndscope, add to MEDM exec list
ndscope_path=$(command -v ndscope)
if [ -x "$ndscope_path" ] ; then
    if [[ "${MEDM_EXEC_LIST}" != *"ndscope"* ]]; then 	
        export MEDM_EXEC_LIST="${MEDM_EXEC_LIST}:ndscope;ndscope &P &"
    fi
fi

# - set up gige camera tools
if [ -e ${APPSROOT}/camera/etc/camera-user-env.sh ] ; then
     source ${APPSROOT}/camera/etc/camera-user-env.sh
fi

# ** setup ligotools **
if [[ -d ${APPSROOT}/ligotools ]] ; then
    if [ -e ${APPSROOT}/ligotools/bin/use_ligotools ] ; then
        eval `${APPSROOT}/ligotools/bin/use_ligotools`
    else
        export LIGOTOOLS=${APPSROOT}/ligotools
        export TCLLIBPATH=${APPSROOT}/ligotools/lib/tconvert
        addpath ${APPSROOT}/ligotools/bin
    fi
fi

# -- MATLAB applications --
# ** setup MATLAB **
if [[ -d ${APPSROOT}/matlab ]] ; then
    export MATLABROOT=${APPSROOT}/matlab
    prepath ${MATLABROOT}/bin
fi
# ** setup awgstream matlab
if [ -e ${APPSROOT}/awgstream-matlab/etc/awgstream-user-env.sh ] ; then
    source ${APPSROOT}/awgstream-matlab/etc/awgstream-user-env.sh
fi
# ** setup NDS2 client
if [ -e ${APPSROOT}/nds2-client/etc/nds2-client-user-env.sh ] ; then
    source ${APPSROOT}/nds2-client/etc/nds2-client-user-env.sh
else
    USING_SYSTEM_NDS2CLIENT=1
    export USING_SYSTEM_NDS2CLIENT
# Get path to  NDS2 jar file
    if [ -e "/usr/lib64/nds2-client/java/nds2.jar" ] ; then
        export NDS2_JAR_PATH="/usr/lib64/nds2-client/java/nds2.jar"
    fi
fi
# ** setup ligoDV  **
if [ -e ${APPSROOT}/ligodv/etc/ligodv-user-env.sh ] ; then
    source ${APPSROOT}/ligodv/etc/ligodv-user-env.sh
fi

# ** setup mDV **
if [ -d ${APPSROOT}/mDV ] ; then
    addmatlab ${APPSROOT}/mDV
fi
